C
C     Sort subroutine copied from "Numerical Recipes"
C     (Fortran; 1st edition; subroutine INDEXX).      
C
      SUBROUTINE ISORT(N,ARRIN,INDX)

C     Modified to sort in descending, rather than ascending order.
C
C     This subroutine uses a Heapsort sorting algorithm.
C     Note that the 2nd Edition of "Numerical Recipes" uses
C     a Quicksort sorting algorithm in its INDEXX subroutine.

      IMPLICIT NONE

C     Formal parameters
      INTEGER N
      INTEGER ARRIN(N),INDX(N)  !ORIGINAL WERE REAL'S

C     Local variables
      INTEGER I,J,L,IR,Q,INDXT

C     Initialize.
      DO J=1,N
         INDX(J) = J
      END DO
      IF (N .LT. 2) THEN
         RETURN
      END IF

 10   CONTINUE
      L = N/2 + 1
      IR = N

 15   CONTINUE
      IF (L .GT. 1) THEN
         L = L-1
         INDXT = INDX(L)
         Q = ARRIN(INDXT)
      ELSE
         INDXT = INDX(IR)
         Q = ARRIN(INDXT)
         INDX(IR) = INDX(1)
         IR = IR-1
         IF (IR .EQ. 1) THEN
            INDX(1) = INDXT
            RETURN
         ENDIF
      ENDIF
      I = L
      J = L + L
 20   IF (J .LE. IR) THEN
         IF (J .LT. IR) THEN
C           IF (ARRIN(INDX(J)) .LT. ARRIN(INDX(J+1))) J = J+1 !original
            IF (ARRIN(INDX(J)) .GT. ARRIN(INDX(J+1))) J = J+1 !modified
         ENDIF
C        IF (Q .LT. ARRIN(INDX(J))) THEN   !original
         IF (Q .GT. ARRIN(INDX(J))) THEN   !modified
            INDX(I) = INDX(J)
            I = J
            J = J + J
         ELSE
            J = IR + 1
         ENDIF
         GOTO 20
      ENDIF
      INDX(I) = INDXT
      GOTO 15

      END
