C
C     Modify slit arrangement manually.
C
C     Aug-1997 - Changed *_WSLIT variables to *_SLIT_WID.         [PLS]
C     Sep-1997 - Made globals SLIT_SEP and SLIT_LEN.              [PLS]
C     Oct-1997 - Added "add box slit" (B) command.                [PLS]
C     Oct-1997 - Added (H) as additional help key.                [PLS]
C     Oct-1997 - Print help text for unrecognized command.        [PLS]
C     Oct-1997 - Ignore \r, \n, \t in interactive mode.           [PLS]

      LOGICAL FUNCTION MANUAL_SLITS(FXMIN,FXMAX,FYMIN,FYMAX,TITLE,
     :                              LPRIORITY,THETA,SLIT_WID,SLIT_LEN,
     :                              SLIT_SEP,PLOT_FLAGS,ENG_TEST)

      IMPLICIT  NONE

      INCLUDE 'autoslit.inc'

C     Formal parameters
      REAL*4    FXMIN,FXMAX,FYMIN,FYMAX
      REAL*4    SLIT_WID,SLIT_LEN,SLIT_SEP
      REAL*8    THETA
      CHARACTER TITLE*80
      INTEGER*4 LPRIORITY
      LOGICAL   PLOT_FLAGS(6),ENG_TEST

C     Local variables
      REAL*4    X,Y
      INTEGER*4 I,OBJ,OBJ_ID,SLIT_ID,T_STYPE,T_SIND
      CHARACTER OBJNAME*40,CH*1,REPLY*10
      LOGICAL   DONE,ERROR

C     Functions
      INTEGER*4 LOCATE_OBJECT,NEAREST_OBJECT,NEAREST_SLIT
      LOGICAL   ADD_SLIT,DELETE_SLIT

C     Loop reading cursor and acting accordingly.
      DONE = .TRUE.             ! assume one iteration
      ERROR = .FALSE.
      CH = 'R'                  ! start by drawing plot
      MARKER = .FALSE.
      DO WHILE (CH .NE. 'Q')

C        Erase any markers.
         IF (MARKER) THEN
            CALL PGSCI (0)
            CALL PGSCH (MARKCH)
            CALL PGPT (1, MARKX, MARKY, MARKPT)
            CALL PGSCH (1.0)
            MARKER = .FALSE.
         END IF

C        Command: POSITION.
         IF (CH .EQ. ' ') THEN
            WRITE(*,*)''
            WRITE(*,11) X,Y
 11         FORMAT(' mask position: ',F7.2,' , ',F7.2)

C        Command: GOTO.
         ELSE IF (CH .EQ. 'M') THEN
            WRITE(*,*)''
            WRITE(*,16)
 16         FORMAT(' Enter name of object to mark:  ',$)
            READ(*,FMT='(A)') OBJNAME
            OBJ = LOCATE_OBJECT (OBJNAME)
            IF (OBJ .GT. 0) THEN
               IF (OBJ_OUT(OBJ)) THEN
                  WRITE(*,*)''
                  WRITE(*,17)
     :                  ' *******************************************'
                  WRITE(*,17)
     :                  ' Object not in field: '//OBJNAME
 17               FORMAT(A)
                  WRITE(*,17)
     :                  ' *******************************************'
               ELSE
                  MARKX = OBJ_T_X(OBJ)
                  MARKY = OBJ_T_Y(OBJ)
                  CALL PGSCI (MARKCI)
                  CALL PGSCH (MARKCH)
                  CALL PGPT (1, MARKX, MARKY, MARKPT)
                  CALL PGSCH (1.0)
                  MARKER = .TRUE.
               END IF
            ELSE
               WRITE(*,*)''
               WRITE(*,18)' *******************************************'
               WRITE(*,18)
     :              ' Unable to locate object: '//OBJNAME
               WRITE(*,18)' *******************************************'
 18            FORMAT(A)
            END IF

C        Command: ADD STANDARD SLIT.
         ELSE IF (CH .EQ. 'O') THEN
            OBJ_ID = NEAREST_OBJECT(X,Y)
            IF (ADD_SLIT(OBJ_ID,THETA,SLIT_LEN,SLIT_SEP,
     :                   PLOT_FLAGS(2),ENG_TEST)) THEN
               CALL PLOT_SLIT(NSLITS,SLIT_WID,THETA,1)
            ELSE
               WRITE(*,*)''
               WRITE(*,21)' *******************************************'
               WRITE(*,21)
     :              ' Unable to add slit to object: '//ONAMES(OBJ_ID)
               WRITE(*,21)' *******************************************'
 21            FORMAT(A)
            END IF
         
C        Command: ADD BOX SLIT.
         ELSE IF (CH .EQ. 'B') THEN
            IF (NBOX .EQ. MAXBOXES) THEN
               WRITE(*,*)''
               WRITE(*,22)' *******************************************'
               WRITE(*,22)
     :              ' MAXBOXES exceeded; unable to add box slit'
               WRITE(*,22)' *******************************************'
 22            FORMAT(A)
            ELSE
               OBJ_ID = NEAREST_OBJECT(X,Y)
C              Create new box slit.
               NBOX = NBOX + 1
               NSPECIAL = NSPECIAL + 1
               BOX_SIZE(NBOX) = DEF_BOX_SIZE * SCALE
C              Tentatively assign box slit, saving old values.
               T_STYPE = OBJ_STYPE(OBJ_ID)
               T_SIND = OBJ_SIND(OBJ_ID)
               OBJ_STYPE(OBJ_ID) = BOX_SLIT
               OBJ_SIND(OBJ_ID) = NBOX
C              Add box slit.
               IF (ADD_SLIT(OBJ_ID,THETA,SLIT_LEN,SLIT_SEP,
     :                      PLOT_FLAGS(2),ENG_TEST)) THEN
C                 Finish box slit and object.
                  BOX_OBJ(NBOX) = OBJ_ID
                  BOX_OBJ_NAME(NBOX) = ONAMES(OBJ_ID)
                  PRIORS(OBJ_ID) = BOX_PRIOR + NBOX
C                 Plot slit.
                  CALL PLOT_SLIT(NSLITS,SLIT_WID,THETA,1)
               ELSE
C                 Remove box slit, restoring old values.
                  NBOX = NBOX - 1
                  NSPECIAL = NSPECIAL - 1
                  OBJ_STYPE(OBJ_ID) = T_STYPE
                  OBJ_SIND(OBJ_ID) = T_SIND
                  WRITE(*,*)''
                  WRITE(*,26)
     :             ' *******************************************'
                  WRITE(*,26)
     :             ' Unable to add box slit to object: '//ONAMES(OBJ_ID)
                  WRITE(*,26)
     :             ' *******************************************'
 26               FORMAT(A)
               END IF
            END IF
         
C        Command: DELETE SLIT.
         ELSE IF (CH .EQ. 'D') THEN
            SLIT_ID = NEAREST_SLIT(X,Y)
            IF (SLIT_ID .GT. 0) THEN
               OBJ_ID = SLIT_OBJ(SLIT_ID)
               CALL PLOT_SLIT(SLIT_ID,SLIT_WID,THETA,0)
               IF (.NOT. DELETE_SLIT(OBJ_ID)) THEN
                  WRITE(*,*)''
                  WRITE(*,31)
     :                 ' *******************************************'
                  WRITE(*,31)
     :            ' Unable to delete slit from object: '//ONAMES(OBJ_ID)
                  WRITE(*,31)
     :                 ' *******************************************'
 31               FORMAT(A)
                  CALL PLOT_SLIT(SLIT_ID,SLIT_WID,THETA,1)
               END IF
            END IF

C        Command: DELETE ALL SLITS.
         ELSE IF (CH .EQ. 'W') THEN
C           Confirm with user first.
            WRITE(*,*)''
            WRITE(*,40)
 40         FORMAT(' Are you sure?  ',$)
            READ(*,FMT='(A)') REPLY
            IF ((REPLY(1:1) .EQ. 'Y') .OR. (REPLY(1:1) .EQ. 'y')) THEN
               DO I=NSLITS,1,-1
                  OBJ_ID = SLIT_OBJ(I)
                  IF (OBJ_STYPE(OBJ_ID) .EQ. STD_SLIT) THEN
                     CALL PLOT_SLIT(I,SLIT_WID,THETA,0)
                     IF (.NOT. DELETE_SLIT(OBJ_ID)) THEN
                        WRITE(*,*)''
                        WRITE(*,41)
     :                    ' *******************************************'
                        WRITE(*,41)
     :            ' Unable to delete slit from object: '//ONAMES(OBJ_ID)
                        WRITE(*,41)
     :                    ' *******************************************'
 41                     FORMAT(A)
                        CALL PLOT_SLIT(I,SLIT_WID,THETA,1)
                     END IF
                  END IF
               END DO
            END IF
               
C        Command: LIST SLITS.
         ELSE IF (CH .EQ. 'L') THEN
            WRITE(*,*)''
            WRITE(*,51)' ==========================================='
            WRITE(*,51)'              Slit Assignments'
            WRITE(*,51)' -------------------------------------------'
            WRITE(*,51)' Slit Type Object                X       Y'
            WRITE(*,51)' -------------------------------------------'
 51         FORMAT(A)
            DO I=1,NSLITS
               OBJ_ID = SLIT_OBJ(I)
               WRITE(*,57) I
 57            FORMAT(' ',I3,$)
               IF (OBJ_STYPE(OBJ_ID) .EQ. STD_SLIT) THEN
                  WRITE(*,58)'slit'
               ELSE IF (OBJ_STYPE(OBJ_ID) .EQ. TILT_SLIT) THEN
                  WRITE(*,58)'tilt'
               ELSE IF (OBJ_STYPE(OBJ_ID) .EQ. ARC_SLIT) THEN
                  WRITE(*,58)' arc'
               ELSE IF (OBJ_STYPE(OBJ_ID) .EQ. LINE_SLIT) THEN
                  WRITE(*,58)'line'
               ELSE IF (OBJ_STYPE(OBJ_ID) .EQ. BOX_SLIT) THEN
                  WRITE(*,58)' box'
               END IF
 58            FORMAT('  ',A4,$)
               WRITE(*,59) ONAMES(OBJ_ID)(1:18),
     :                     OBJ_T_X(OBJ_ID),OBJ_T_Y(OBJ_ID)
 59            FORMAT(' ',A18,F7.2,' ',F7.2)
            END DO
            WRITE(*,61)' ==========================================='
 61         FORMAT(A)

C        Command: INFO.
         ELSE IF (CH .EQ. 'I') THEN
            OBJ_ID = NEAREST_OBJECT(X,Y)
            WRITE(*,*)''
            WRITE(*,71) ONAMES(OBJ_ID)
 71         FORMAT(' OBJECT: ',A)
            WRITE(*,72) PRIORS(OBJ_ID)
 72         FORMAT(' priority:      ',I4)
            WRITE(*,73) OBJ_T_X(OBJ_ID),OBJ_T_Y(OBJ_ID)
 73         FORMAT(' mask position:  ',F7.2,' , ',F7.2)
            IF (OBJ_HIT(OBJ_ID)) THEN
               WRITE(*,74) OBJ_SLIT(OBJ_ID)
 74            FORMAT(' slit assigned: ',I4,$)
               IF (OBJ_STYPE(OBJ_ID) .EQ. STD_SLIT) THEN
                  WRITE(*,76)'  [standard slit]'
               ELSE IF (OBJ_STYPE(OBJ_ID) .EQ. TILT_SLIT) THEN
                  WRITE(*,76)'  [tilted slit]'
               ELSE IF (OBJ_STYPE(OBJ_ID) .EQ. ARC_SLIT) THEN
                  WRITE(*,76)'  [arc slit]'
               ELSE IF (OBJ_STYPE(OBJ_ID) .EQ. LINE_SLIT) THEN
                  WRITE(*,76)'  [line segment slit]'
               ELSE IF (OBJ_STYPE(OBJ_ID) .EQ. BOX_SLIT) THEN
                  WRITE(*,76)'  [box slit]'
               END IF
 76            FORMAT(A)
            ELSE
               WRITE(*,78)' no slit assigned'
 78            FORMAT(A)
            END IF
            WRITE(*,80) LINE(OBJ_ID)(1:60)
 80         FORMAT(' ',A60,'...')

C        Command: HELP.
         ELSE IF ((CH .EQ. 'H') .OR. (CH .EQ. '?')) THEN
            WRITE(*,91)''
            WRITE(*,91)' ==========================================='
            WRITE(*,91)'           Interactive Commands'
            WRITE(*,91)' -------------------------------------------'
            WRITE(*,91)' Slit information:'
            WRITE(*,91)' -----------------'
            WRITE(*,91)' <sp> : get position info'
            WRITE(*,91)'  I   : get info about an object'
            WRITE(*,91)'  L   : list objects in slits '
            WRITE(*,91)'  M   : mark a specified object'
            WRITE(*,91)' -------------------------------------------'
            WRITE(*,91)' Slit assignment:'
            WRITE(*,91)' ----------------'
            WRITE(*,91)'  O   : assign a slit to an object'
            WRITE(*,91)'  B   : assign a box slit to an object'
            WRITE(*,91)'  D   : delete a slit assignment'
            WRITE(*,91)'  W   : wipeout standard slit assignments'
            WRITE(*,91)'  Z   : wipeout all slit assignments'
            WRITE(*,91)' -------------------------------------------'
            WRITE(*,91)' Field adjustment:'
            WRITE(*,91)' -----------------'
            WRITE(*,91)'  C   : specify field offset (relative)'
            WRITE(*,91)'  P   : specify field position angle'
            WRITE(*,91)' -------------------------------------------'
            WRITE(*,91)' Miscellaneous:'
            WRITE(*,91)' --------------'
            WRITE(*,91)'  H,? : help'
            WRITE(*,91)'  R   : redraw slitmask'
            WRITE(*,91)'  Q   : exit this routine'
            WRITE(*,91)' ==========================================='
 91         FORMAT(A)

C        Command: REDRAW.
         ELSE IF (CH .EQ. 'R') THEN
C           Plot slitmask.
            CALL PLOT_MASK(FXMIN,FXMAX,FYMIN,FYMAX,TITLE,LPRIORITY,
     :                     THETA,SLIT_WID,PLOT_FLAGS)
C           Label plot.
            CALL PGIDEN

C        Command: DELETE ALL SLITS.
         ELSE IF (CH .EQ. 'Z') THEN
C           Confirm with user first.
            WRITE(*,*)''
            WRITE(*,101)
 101        FORMAT(' Are you sure?  ',$)
            READ(*,FMT='(A)') REPLY
            IF ((REPLY(1:1) .EQ. 'Y') .OR. (REPLY(1:1) .EQ. 'y')) THEN
               DO I=NSLITS,1,-1
                  OBJ_ID = SLIT_OBJ(I)
                  CALL PLOT_SLIT(I,SLIT_WID,THETA,0)
                  IF (.NOT. DELETE_SLIT(OBJ_ID)) THEN
                     WRITE(*,*)''
                     WRITE(*,103)
     :                 ' *******************************************'
                     WRITE(*,103)
     :            ' Unable to delete slit from object: '//ONAMES(OBJ_ID)
                     WRITE(*,103)
     :                 ' *******************************************'
 103                 FORMAT(A)
                     CALL PLOT_SLIT(I,SLIT_WID,THETA,1)
                  END IF
               END DO
            END IF

C	 Command: CHANGE FIELD CENTER (OFFSET)
         ELSE IF (CH .EQ. 'C') THEN
            WRITE(*,*)''
            WRITE(*,111)
 111        FORMAT(' Enter relative offset for field [X" Y"]:  ',$)
            READ(*,*) X, Y
            
C           Delete current slit assignments.
            DO I=NSLITS,1,-1
               OBJ_ID = SLIT_OBJ(I)
               IF (.NOT. DELETE_SLIT(OBJ_ID)) THEN
                  WRITE(*,*)''
                  WRITE(*,113)
     :            ' *******************************************'
                  WRITE(*,113)
     :            ' Unable to delete slit from object: '//ONAMES(OBJ_ID)
                  WRITE(*,113)
     :            ' *******************************************'
 113              FORMAT(A)
               END IF
            END DO
            IF (NSLITS .EQ. 0) THEN
               NSLITS = UNDEFINED
            END IF

C           Shift field.
            X = X * SCALE
            Y = Y * SCALE
            CALL XYSHIFT(X,Y,THETA)

C           Quit and reset coordinates.
            DONE = .FALSE.
            GOTO 501

C	 Command: CHANGE POSITION ANGLE
         ELSE IF (CH .EQ. 'P') THEN
            WRITE(*,*)''
            WRITE(*,121)
 121        FORMAT(' Enter new position angle for field:  ',$)
            READ(*,*) THETA

C           Delete current slit assignments.
            DO I=NSLITS,1,-1
               OBJ_ID = SLIT_OBJ(I)
               IF (.NOT. DELETE_SLIT(OBJ_ID)) THEN
                  WRITE(*,*)''
                  WRITE(*,123)
     :            ' *******************************************'
                  WRITE(*,123)
     :            ' Unable to delete slit from object: '//ONAMES(OBJ_ID)
                  WRITE(*,123)
     :            ' *******************************************'
 123              FORMAT(A)
               END IF
            END DO
            IF (NSLITS .EQ. 0) THEN
               NSLITS = UNDEFINED
            END IF

C           Rotate field.
            THETA = -THETA      ! internal theta opposite
            CALL XYPOS(THETA)

C           Adjust positions to place guide star in pickoff mirror.
            IF (PLOT_FLAGS(2)) THEN
               X = OBJ_T_X(GUIDE_OBJ) - G_X
               Y = OBJ_T_Y(GUIDE_OBJ) - G_Y
               CALL XYSHIFT(X,Y,THETA)
            END IF

C           Quit and reset coordinates.
            DONE = .FALSE.
            GOTO 501

C        Command: <NEWLINE>, <RETURN>, <TAB>
         ELSE IF ((CH .EQ. '\r') .OR. (CH .EQ. '\n') .OR.
     :            (CH .EQ. '\t')) THEN
C           Do nothing...
C           WRITE(*,*) CH

C        Command: not recognized.
         ELSE IF (CH .NE. 'Q') THEN
            WRITE(*,201)' Command not recognized: ',CH
 201        FORMAT(A,A1)
            ERROR = .TRUE.

         END IF

C        Read next command.
         IF (ERROR) THEN
            CH = 'H'
            ERROR = .FALSE.
         ELSE
C           Read PGPLOT cursor.
            CALL PGCURS(X,Y,CH)
            IF ((CH .GE. 'a') .AND. (CH .LE. 'z'))
     :           CH = CHAR(ICHAR(CH(1:1))-32)
         END IF

      END DO

 501  MANUAL_SLITS = DONE
      RETURN
      END
