C
C     Create output file 2, in which all the objects in the field
C     are given with their field coordinates
C     
C     Aug-1997 - Changed *_WSLIT variables to *_SLIT_WID.         [PLS]
C     Sep-1997 - Made globals SLIT_SEP and SLIT_LEN.              [PLS]

      SUBROUTINE WRITE_OBJECTS (INPUT, OUTPUT, OUT2, OUT3, PRIORITY,
     :                          RANK_TOP, RANK_BOT, NEW_EPOCH,
     :                          SLIT_WID, SLIT_LEN, SLIT_SEP,
     :                          TEMP, PRES, WAVE, LAT, POS_ANGLE, H,
     :                          MIRROR_USE, ENG_TEST, INTERACTIVE)

      IMPLICIT NONE

      INCLUDE 'autoslit.inc'

C     Formal parameters
      CHARACTER INPUT*40,OUTPUT*40,OUT2*40,OUT3*40
      INTEGER*4 PRIORITY,RANK_TOP,RANK_BOT
      REAL*4    NEW_EPOCH
      REAL*4    SLIT_WID,SLIT_LEN,SLIT_SEP
      REAL*8    TEMP,PRES,WAVE,LAT,POS_ANGLE,H
      LOGICAL   MIRROR_USE,ENG_TEST,INTERACTIVE

C     Local variables
      CHARACTER TODAY*24
      INTEGER*4 I,IOS,OLUN
      LOGICAL   VERBOSE

      WRITE(*,*)''
      WRITE(*,11)' Writing astrometry file...'
 11   FORMAT(A)

C     Open output astrometry file.
      OLUN = 20
      OPEN(OLUN,FILE=OUT2,FORM='FORMATTED',STATUS='UNKNOWN',
     :     IOSTAT=IOS)
      IF (IOS .NE. 0) THEN
         WRITE(*,30) OUT2
 30      FORMAT(' Unable to open output file: ',A)
         STOP 'Aborting...'
      END IF

C     Output header information.
      WRITE(OLUN,*)''
      WRITE(OLUN,40) VERSION
 40   FORMAT('   ****       AUTOSLIT  ',F3.1,' OUTPUT        ****')
      CALL FDATE(TODAY)
      WRITE(OLUN,41) TODAY
 41   FORMAT('   ****     ',A24,'      ****')
      WRITE(OLUN,*)''

C     Output summary of physical parameters.
      VERBOSE = .FALSE.
      CALL PRINT_PARAMS (INPUT, OUTPUT, OUT2, OUT3, PRIORITY,
     :                   RANK_TOP, RANK_BOT, NEW_EPOCH, SLIT_WID,
     :                   SLIT_LEN, SLIT_SEP, TEMP, PRES, WAVE,
     :                   LAT, POS_ANGLE, H, MIRROR_USE, ENG_TEST,
     :                   INTERACTIVE, VERBOSE, LDL2, RDL2, OLUN)

C     Output guide star information.
      IF (MIRROR_USE) THEN
         WRITE(OLUN,*)''
         WRITE(OLUN,58)'   ==========================================='
         WRITE(OLUN,58)'               Guide Star Identity'
         WRITE(OLUN,58)'   -------------------------------------------'
 58      FORMAT(A)
         IF (MIRROR_USE) THEN
            WRITE(OLUN,60) NSPECIAL
 60         FORMAT(' Guide star is STAR #',I4)
            WRITE(OLUN,61) LINE(GUIDE_OBJ)(1:40)
 61         FORMAT(' ',A40,'...')
         ELSE
            WRITE(OLUN,62)' No suitable guide stars'
 62         FORMAT(A)
         END IF
         WRITE(OLUN,65)' ==========================================='
         WRITE(OLUN,*)''
 65      FORMAT(A)
      END IF

C     Output listing of slits/objects in field.
      WRITE(OLUN,*)''
      WRITE(OLUN,69)'   ==========================================='
      WRITE(OLUN,69)'                Objects in Field'
      WRITE(OLUN,69)'   -------------------------------------------'
      WRITE(OLUN,69)'    Name                Mag        X       Y'
      WRITE(OLUN,69)'   -------------------------------------------'
 69   FORMAT(A)
      DO I=1,NPTS
         IF (.NOT. OBJ_OUT(I)) THEN 
            WRITE(OLUN,70) ONAMES(I), MAGS(I), OBJ_T_X(I), OBJ_T_Y(I)
 70         FORMAT('   ',A20,F5.2,'   ',F7.2,' ',F7.2)
         END IF
      END DO
      WRITE(OLUN,71)'   ==========================================='
 71   FORMAT(A)

C     Clean up and quit.
      WRITE(*,101) OUT2
 101  FORMAT(' File written: ',A)
      CLOSE(OLUN)
      RETURN

      END
