         program tilted_slit
C
C   This program is a aid for designing tilted slits.  You input
C   the RA and Dec for three points (top, middle, and bottom),
C   where top is one end, bottom is the other end, and "middle"
C   is the design center, not necessarily in the middle of the length
C   of the slit.
C   
C    The output is the position angle and the length (N-S) from
C    the "middle" to the top and to the bottom.
C
C    Judy Cohen - Caltech - Sep 1997
C
        parameter (ntry=20)
        real*8  ras(3),decs(3),ra_arcs(3)
        write(*,*)' Warning: Program does not work correctly for '
        write(*,*)' dec between 0 and -1 degrees. '
        write(*,*)'  '
        do i=1,ntry
            write(*,*)
     :        ' Input Ra and dec, format hh mm ss.s +dd mm ss.s '
            write(*,*)'   '
            write(*,*)' top = most North location '
            read(*,*)irah,iram,rs,idd,idm,ds
            ras(1)=3600.0*float(irah)+60.0*float(iram)+rs
            ival=abs(idd)
            decs(1)=3600.0*float(ival)+60.0*float(idm)+ds
            if (idd.lt. 0) decs(1)=-decs(1)
C            
C   Read in ``middle''
C
            write(*,*)'   '
            write(*,*)' middle location '
            read(*,*)irah,iram,rs,idd,idm,ds
            ras(2)=3600.0*float(irah)+60.0*float(iram)+rs
            ival=abs(idd)
            decs(2)=3600.0*float(ival)+60.0*float(idm)+ds
            if (idd.lt. 0) decs(2)=-decs(2)
            dec0=abs(idd)+float(idm)/60.0+ds/3600.0
            if (idd.lt. 0)dec0=-dec0
C
C   read in bottom
C
            write(*,*)'   '
            write(*,*)' bottom (most Southern) location '
            read(*,*)irah,iram,rs,idd,idm,ds
            ras(3)=3600.0*float(irah)+60.0*float(iram)+rs
            ival=abs(idd)
            decs(3)=3600.0*float(ival)+60.0*float(idm)+ds
            if (idd.lt. 0) decs(3)=-decs(3)
C
C   turn ra(sec of time) into arc-sec
C
            do j=1,3
               ra_arcs(j)=15.0*cosd(dec0)*ras(j)
            end do
C
C   N-S distances in arc-sec
C
            d1=decs(1)-decs(2)
            d2=decs(2)-decs(3)
            write(*,100)d1
  100 format(' Distance N-S top-middle (arc-sec)     = ',f7.2)
            write(*,101)d2
  101 format(' Distance N-S middle -bottom (arc-sec) = ',f7.2)

C
C   Now angles, if upper is west of lower, PA is negative
C
            tan12=abs((ra_arcs(1)-ra_arcs(2)))/(decs(1)-decs(2))
            tan23=abs((ra_arcs(2)-ra_arcs(3)))/(decs(2)-decs(3))
            tan13=abs((ra_arcs(1)-ra_arcs(3)))/(decs(1)-decs(3))
            a12=atand(tan12)
            a23=atand(tan23)
            a13=atand(tan13)
            isign12=1
            if ((ra_arcs(1)-ra_arcs(2)) .lt. 0.0) isign12=-1
            isign23=1
            if ((ra_arcs(2)-ra_arcs(3)) .lt. 0.0) isign23=-1
            isign13=1
            if ((ra_arcs(1)-ra_arcs(3)) .lt. 0.0) isign13=-1
            write(*,*)'  '
            write(*,*)' Position angles T-M, M-B, and T-B '
            write(*,102)a12,a23,a13
  102    format(3(3x,f8.2))
            write(*,*)' Signs for PAs, T-M, M-B and T-B '
            write(*,103)isign12,isign23,isign13
  103  format(3(3x,i2))
            write(*,*)'   '
        end do
        end
